﻿;========================================================================================================================================
; Create the keyboard shortcuts loader
;========================================================================================================================================

Procedure LoadkeyboardShortCutsFile()
  
  ;----------------------------------------------------------------------------------------------
  ; Proceed if there is a predefined project directory
  ;----------------------------------------------------------------------------------------------
  
  OutputFilename.s = Program\ModuleDirectory + "_LoadkeyboardShortCuts.pbi"
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
  If OutputFilename.s
    
    ;--------------------------------------------------------------------------------------------
    ; Create the output file to save to
    ;--------------------------------------------------------------------------------------------
    
    OutputFileHandle.i = CreateFile(#PB_Any, OutputFilename.s)
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
    
    If OutputFileHandle.i
      
      ;******************************************************************************************
      ; Write the keyboard shortcuts loader. This always goes into %INCLUDES%\Custom
      ;******************************************************************************************
      
      WriteHeadingToOutputFile(OutputFileHandle.i, "; Keyboard shortcuts loader procedure")
      
      WriteStringN(OutputFileHandle.i,            "PROCEDURE LoadkeyboardShortCuts()")
      
      WriteStringN(OutputFileHandle.i,            "")
                   
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "  ; Remove all existing shortcuts for this window")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")

      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "  RemoveKeyboardShortcut(" + "#" + Program\WindowName + ", #PB_Shortcut_All)")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "  ; Load the keyboard shortcuts from the system database")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "  If DatabaseQuery(Program\DatabaseHandle, " + Chr(34) + "Select * FROM KeyboardShortcuts WHERE Record='1'" + Chr(34))
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "    While NextDatabaseRow(Program\DatabaseHandle)")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      RowCounter.i = 0
      
      ForEach Keys.s()
        
        If Left(Keys()\KeyDataName, 1) <> "~" And Right(Keys()\KeyDataName, 1) <> "~"
          
          CurrentKey.s = FormatField("Keys\" + Keys()\KeyDataText, 30) + " = Val(GetDatabaseString(Program\DatabaseHandle,  " + Str(RowCounter.i) + "))"
          
          RowCounter.i + 1
          
          WriteStringN(OutputFileHandle.i, "      " + CurrentKey.s)
          
          WriteStringN(OutputFileHandle.i,       "")
          
        EndIf
        
      Next           
        
      WriteStringN(OutputFileHandle.i,            "    Wend")
      
      WriteStringN(OutputFileHandle.i,            "  ;")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "  ;")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "    FinishDatabaseQuery(Program\DatabaseHandle)")
      
      WriteStringN(OutputFileHandle.i,            "  ;")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "  ; Reload the shortcuts with the new values.")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      ForEach Keys.s()
        
        If Left(Keys()\KeyDataName, 1) <> "~" And Right(Keys()\KeyDataName, 1) <> "~"
          
          CurrentKey.s = "AddKeyboardShortcut(" + "#" + Program\WindowName + ", " + FormatField("Keys\" + Keys()\KeyDataText + ", ", 30) + "#ShortCut_" + Keys()\KeyDataText + ")"
          
          WriteStringN(OutputFileHandle.i,          "    " + CurrentKey.s)
          
          WriteStringN(OutputFileHandle.i,         "")
          
        EndIf
        
      Next           
      
      WriteStringN(OutputFileHandle.i,            "  Else")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "    ; Problem with the database query")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "  EndIf")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "EndProcedure")
      
      ;------------------------------------------------------------------------------------------
      ; Close the output file as we are finished writing to it
      ;------------------------------------------------------------------------------------------
      
      CloseFile(OutputFileHandle.i)
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
    Else
      
      SetGadgetText(#Gadget_ShortCutter_messages, Str(OutputFileHandle.i) + " could not be created")
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
      
  Else
    
    SetGadgetText(#Gadget_ShortCutter_messages, OutputFileName.s + " does not exist")
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
    
EndProcedure

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 168
; FirstLine = 130
; Folding = -
; EnableXP
; HideErrorLog