﻿;========================================================================================================================================
; Create the main program menu file
;========================================================================================================================================

Procedure MainMenuFile()
  
  ;----------------------------------------------------------------------------------------------
  ; Proceed if there is a predefined project directory
  ;----------------------------------------------------------------------------------------------
  
  OutputFileName.s = Program\ModuleDirectory + "_CreateMainMenu.pbi"
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
  If OutputFileName.s
    
    ;--------------------------------------------------------------------------------------------
    ; Create the output file to save to
    ;--------------------------------------------------------------------------------------------
    
    OutputFileHandle.i = CreateFile(#PB_Any, OutputFileName.s)
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
    
    If OutputFileHandle.i
      
      ;******************************************************************************************
      ; Write the image menu creation area. This always goes into %INCLUDES%\Custom
      ;******************************************************************************************
      
      WriteHeadingToOutputFile(OutputFileHandle.i, "; Image menu creation procedure")
      
      WriteStringN(OutputFileHandle.i,            "PROCEDURE CreateMainMenu()")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "  ; ")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "  ; Remove all existing shortcuts for this window")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "  CreateImageMenu(#MenuBar_" + Program\WindowName + ", WindowID(" + "#" + Program\WindowName + "), #PB_Menu_ModernLook")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      ForEach Keys.s()
        
        If Left(Keys()\KeyDataName, 1) = "~" And Right(Keys()\KeyDataName, 1) = "~"
          
          WriteStringN(OutputFileHandle.i, "  ----------------------------------------")
          
          WriteStringN(OutputFileHandle.i, "  MenuTitle(" + Chr(34) + ReplaceString(Keys()\KeyDataText, "~", "") + Chr(34))
          
          WriteStringN(OutputFileHandle.i, "  ----------------------------------------")
          
          WriteStringN(OutputFileHandle.i,            "")
          
        Else
          
          WriteStringN(OutputFileHandle.i, FormatField("    MenuItem(#MenuBar_" + Keys()\KeyDataText + ", ", 70) + FormatField("MenuText\" + Keys()\KeyDataText, 45) + " + Chr(09) + " + FormatField("GetShortcutText(Keys\" + Keys()\KeyDataText + "),", 55) + FormatField("ImageID(#MenuBarIcon_" + Keys()\KeyDataText + ")", 50))
          
          WriteStringN(OutputFileHandle.i,            "")
          
        EndIf
        
      Next
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "  ; ")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "EndProcedure")
            
      ;------------------------------------------------------------------------------------------
      ; Close the output file as we are finished writing to it
      ;------------------------------------------------------------------------------------------
      
      CloseFile(OutputFileHandle.i)
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
    Else
      
      SetGadgetText(#Gadget_ShortCutter_messages, Str(OutputFileHandle.i) + " could not be created.")
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
      
  Else
    
    SetGadgetText(#Gadget_ShortCutter_messages,  DeclareFileName.s + " does not exist.")
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
    
EndProcedure

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 110
; FirstLine = 81
; Folding = -
; EnableXP
; HideErrorLog