﻿;==========================================================================================================================
; Create the main program file
;==========================================================================================================================

Procedure MainProgramFile()
  
  ;----------------------------------------------------------------------------------------------
  ; Proceed if there is a predefined project directory
  ;----------------------------------------------------------------------------------------------
  
  OutputFileName.s = Program\ProjectDirectory + Program\ProjectName + ".pb"
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
  If OutputFileName.s
    
    ;--------------------------------------------------------------------------------------------
    ; Create the output file to save to
    ;--------------------------------------------------------------------------------------------
    
    OutputFileHandle.i = CreateFile(#PB_Any, OutputFileName.s)
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
    
    If OutputFileHandle.i
        
      ;------------------------------------------------------------------------------------------
      ; Main program file options. This always goes into %MyProgramName%
      ;------------------------------------------------------------------------------------------
      
      WriteHeadingToOutputFile(OutputFileHandle.i, "; Main program files")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + Program\ProjectName + "_Constants.pb"       + Chr(34), 93) + "  ; Visual designer ceated constants")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + Program\ProjectName + "_Windows.pb"         + Chr(34), 93) + "  ; Visual designer ceated constants")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + Program\ProjectName + "_Mydeclarations.pb"  + Chr(34), 93) + "  ; All procedural declarations")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + Program\ProjectName + "_Myconstants.pb"     + Chr(34), 93) + "  ; All my personal constants")
      
      ;------------------------------------------------------------------------------------------
      ; Main program file included modules. This always goes into %MyProgramName%
      ;------------------------------------------------------------------------------------------
      
      WriteHeadingToOutputFile(OutputFileHandle.i, "; Main system include files")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + "Modules\OpenSystemDatabase.pbi"           + Chr(34), 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + "Modules\LoadkeyboardShortCuts.pbi"        + Chr(34), 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + "Modules\CreateMainMenu.pbi"               + Chr(34), 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + "Modules\MakeSureDirectoryPathExists.pbi"  + Chr(34), 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + "Modules\MyBalloonToolTips.pbi"            + Chr(34), 93) + "; ")
      
      WriteStringN(OutputFileHandle.i,            FormatField("XIncludeFile " + Chr(34) + "Modules\SelectWindowToolTips.pbi"         + Chr(34), 93) + "; ")
      
      ;------------------------------------------------------------------------------------------
      ; All the modules belonging to the 'Files' menu
      ;------------------------------------------------------------------------------------------
      
;      WriteHeadingToOutputFile(OutputFileHandle.i, "; 'Files' menu includes")
      
      ForEach Keys.s()
        
        If Left(Keys()\KeyDataName, 1) = "~" And Right(Keys()\KeyDataName, 1) = "~"
          
          WriteStringN(OutputFileHandle.i,  "")
          
          WriteStringN(OutputFileHandle.i,  ";==========================================================================================================================")
          
          WriteStringN(OutputFileHandle.i,  "; " + RemoveString(Keys()\KeyDataText, "~", 1, 1) + " menu includes")
          
          MakeSureDirectoryPathExists(Program\ModuleDirectory + RemoveString(Keys()\KeyDataName, "~", 1, 1))
          
          WriteStringN(OutputFileHandle.i,  ";==========================================================================================================================")
          
          WriteStringN(OutputFileHandle.i,  "")
          
        Else
          
          WriteStringN(OutputFileHandle.i,  FormatField("XIncludeFile " + Chr(34) + "Modules\" + Keys()\KeyDataText + ".pbi" + Chr(34), 93) + "; ")
          
        EndIf
        
      Next
      
      ;------------------------------------------------------------------------------------------
      ; Runtime startup options. This always goes into %MyProgramName%
      ;------------------------------------------------------------------------------------------
      
      WriteHeadingToOutputFile(OutputFileHandle.i, "; Main event handling section")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            " ; Set the startup program quit value flag")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " Program\QuitValue = 0")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            " ; Enable the displaying of balloon tooltips")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " Program\ToolTips = 1")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            " ; Create my main menu")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " CreateMainMenu()")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            " ; Setup the window tool tips")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " SelectWindowToolTips(#" + Program\WindowName + ")")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            " ; Open the master database")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " OpenSystemDatabase()")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            " ; Set focus to main window")
      
      WriteStringN(OutputFileHandle.i,            " ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            " SetActiveWindow(#" + Program\WindowName + ")")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      ;------------------------------------------------------------------------------------------
      ; Event handling section for the shortcuts. This always goes into %MyProgramName%
      ;------------------------------------------------------------------------------------------
      
      WriteStringN(OutputFileHandle.i,            "      ;-----------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "      ; ")
      
      WriteStringN(OutputFileHandle.i,            "      ;-----------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "")
      
      WriteStringN(OutputFileHandle.i,            "      Case #PB_Event_Menu")
      
      WriteStringN(OutputFileHandle.i,            "        Select EventMenu()")

      ForEach Keys.s()
        
        If Left(Keys()\KeyDataName, 1) <> "~" And Right(Keys()\KeyDataName, 1) <> "~"
          
          WriteStringN(OutputFileHandle.i,          "          Case #ShortCut_" + FormatField(Keys()\KeyDataText, 30) + ": " + Keys()\KeyDataText + "()")
          
        Else
          
          WriteStringN(OutputFileHandle.i, ";         " + ReplaceString(Keys()\KeyDataText, "~", "") + " Menu")
          
        EndIf
      Next
      
      
      WriteStringN(OutputFileHandle.i,            "          ;-------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "          ; ")
      
      WriteStringN(OutputFileHandle.i,            "          ;-------------------------------------------")
      
      ForEach Keys.s()
        
        If Left(Keys()\KeyDataName, 1) <> "~" And Right(Keys()\KeyDataName, 1) <> "~"
          
          WriteStringN(OutputFileHandle.i,          "          Case #MenuBar_"  + FormatField(Keys()\KeyDataText, 31) + ": " + Keys()\KeyDataText + "()")
          
        Else
          
          WriteStringN(OutputFileHandle.i, ";         " + ReplaceString(Keys()\KeyDataText, "~", "") + " Menu")
          
        EndIf
        
      Next
      
      WriteStringN(OutputFileHandle.i,            "          ;-------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "          ; ")
      
      WriteStringN(OutputFileHandle.i,            "          ;-------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "        EndSelect")
      
      WriteStringN(OutputFileHandle.i,            "      ;-----------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "      ; ")
      
      WriteStringN(OutputFileHandle.i,            "      ;-----------------------------------------------")
        
      ;------------------------------------------------------------------------------------------
      ; Close the output file as we are finished writing to it
      ;------------------------------------------------------------------------------------------
      
      CloseFile(OutputFileHandle.i)
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
    Else
      
      SetGadgetText(#Gadget_ShortCutter_messages, Str(OutputFileHandle.i) + " could not be created.")
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
      
  Else
    
    SetGadgetText(#Gadget_ShortCutter_messages,  OutputFileName.s + " does not exist.")
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
    
EndProcedure

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 76
; FirstLine = 174
; Folding = -
; EnableXP