﻿;========================================================================================================================================
; Create the directory creator procedure
;========================================================================================================================================

Procedure MakeSureDirectoryPathExistsFile()
  
  ;----------------------------------------------------------------------------------------------
  ; Proceed if there is a predefined project directory
  ;----------------------------------------------------------------------------------------------
  
  OutputFileName.s = Program\ModuleDirectory + "_MakeSureDirectoryPathExists.pbi"
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
  If OutputFileName.s
    
    ;--------------------------------------------------------------------------------------------
    ; Create the output file to save to
    ;--------------------------------------------------------------------------------------------
    
    OutputFileHandle.i = CreateFile(#PB_Any, OutputFileName.s)
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
    
    If OutputFileHandle.i
      
      ;******************************************************************************************
      ; Unicode aware version of directory creation procedure
      ;******************************************************************************************
      
      WriteHeadingToOutputFile(OutputFileHandle.i, "; Need a unicode aware version of the API directory creator")
      
      WriteStringN(OutputFileHandle.i, "Procedure MakeSureDirectoryPathExists(Directory.s)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ResultCode = SHCreateDirectory(#Null, Directory.s)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i, "  ; ")
      
      WriteStringN(OutputFileHandle.i, "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i, "EndProcedure")
      
      ;------------------------------------------------------------------------------------------
      ; Close the output file as we are finished writing to it
      ;------------------------------------------------------------------------------------------
      
      CloseFile(OutputFileHandle.i)
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
    Else
      
      SetGadgetText(#Gadget_ShortCutter_messages, Str(OutputFileHandle.i) + " could not be created.")
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
      
  Else
    
    SetGadgetText(#Gadget_ShortCutter_messages, OutputFileName.s + " does not exist.")
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
    
EndProcedure

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 84
; FirstLine = 56
; Folding = -
; EnableXP