﻿;========================================================================================================================================
; Create the window tooltips selector
;========================================================================================================================================

Procedure SelectWindowToolTipsFile()
  
  ;----------------------------------------------------------------------------------------------
  ; Proceed if there is a predefined project directory
  ;----------------------------------------------------------------------------------------------
  
  OutputFileName.s = Program\ModuleDirectory + "_SelectWindowToolTips.pbi"
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
  
  If OutputFileName.s
    
    ;--------------------------------------------------------------------------------------------
    ; Create the output file to save to
    ;--------------------------------------------------------------------------------------------
    
    OutputFileHandle.i = CreateFile(#PB_Any, OutputFileName.s)
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
    
    If OutputFileHandle.i
      
      ;******************************************************************************************
      ; Select the window to add the balloon tooltips to
      ;******************************************************************************************

      WriteHeadingToOutputFile(OutputFileHandle.i, "; Global tooltips enabler, makes it easier to turn on or off")

      WriteStringN(OutputFileHandle.i,            "Procedure SelectWindowToolTips(Window.i)")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "  ; ")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
            
      WriteStringN(OutputFileHandle.i,            "  If Program\ToolTips = 1")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "    ;----------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "    ; ")
      
      WriteStringN(OutputFileHandle.i,            "    ;----------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "    Select Window.i")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "      ;--------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "      ; ")
      
      WriteStringN(OutputFileHandle.i,            "      ;--------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "      Case #" + Program\WindowName)
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "        ;------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "        ; Example below of how the command would look")
      
      WriteStringN(OutputFileHandle.i,            "        ;------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "        MyBalloonToolTips(#WindowStuff, #VacuumButton + BalloonText\VacuumTables")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "        ;------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "        ; ")
      
      WriteStringN(OutputFileHandle.i,            "        ;------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "    EndSelect")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "    ;----------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "    ; ")
      
      WriteStringN(OutputFileHandle.i,            "    ;----------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "  EndIf")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,            "  ; ")
      
      WriteStringN(OutputFileHandle.i,            "  ;------------------------------------------------------------------------------------------------")
      
      WriteStringN(OutputFileHandle.i,     "")
      
      WriteStringN(OutputFileHandle.i,            "EndProcedure")
      
      ;------------------------------------------------------------------------------------------
      ; Close the output file as we are finished writing to it
      ;------------------------------------------------------------------------------------------
      
      CloseFile(OutputFileHandle.i)
      
      ;------------------------------------------------------------------------------------------
      ; 
      ;------------------------------------------------------------------------------------------
      
    Else
      
      SetGadgetText(#Gadget_ShortCutter_messages, Str(OutputFileHandle.i) + " could not be created.")
      
    EndIf
    
    ;--------------------------------------------------------------------------------------------
    ; 
    ;--------------------------------------------------------------------------------------------
      
  Else
    
    SetGadgetText(#Gadget_ShortCutter_messages, OutputFileName.s + " does not exist.")
    
  EndIf
  
  ;----------------------------------------------------------------------------------------------
  ; 
  ;----------------------------------------------------------------------------------------------
    
EndProcedure

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 144
; FirstLine = 115
; Folding = -
; EnableXP
; HideErrorLog