
;==========================================================================================================================
; Main program files
;==========================================================================================================================

XIncludeFile "AddressBox_Constants.pb"                                                          ; Visual designer ceated constants
XIncludeFile "AddressBox_Windows.pb"                                                            ; Visual designer ceated constants
XIncludeFile "AddressBox_Mydeclarations.pb"                                                     ; All procedural declarations
XIncludeFile "AddressBox_Myconstants.pb"                                                        ; All my personal constants

;==========================================================================================================================
; Main system include files
;==========================================================================================================================

XIncludeFile "Modules\OpenSystemDatabase.pbi"                                                 ; 
XIncludeFile "Modules\LoadkeyboardShortCuts.pbi"                                              ; 
XIncludeFile "Modules\CreateMainMenu.pbi"                                                     ; 
XIncludeFile "Modules\MakeSureDirectoryPathExists.pbi"                                        ; 
XIncludeFile "Modules\MyBalloonToolTips.pbi"                                                  ; 
XIncludeFile "Modules\SelectWindowToolTips.pbi"                                               ; 

;==========================================================================================================================
; Files menu includes
;==========================================================================================================================

XIncludeFile "Modules\OpenDatabase.pbi"                                                       ; 
XIncludeFile "Modules\ReloadMaster.pbi"                                                       ; 
XIncludeFile "Modules\DumpTables.pbi"                                                         ; 
XIncludeFile "Modules\UndumpTables.pbi"                                                       ; 
XIncludeFile "Modules\VacuumTables.pbi"                                                       ; 
XIncludeFile "Modules\ExitProgram.pbi"                                                        ; 

;==========================================================================================================================
; Category menu includes
;==========================================================================================================================

XIncludeFile "Modules\AddCategory.pbi"                                                        ; 
XIncludeFile "Modules\CopyCategory.pbi"                                                       ; 
XIncludeFile "Modules\DeleteCategory.pbi"                                                     ; 
XIncludeFile "Modules\EditCategory.pbi"                                                       ; 

;==========================================================================================================================
; Data menu includes
;==========================================================================================================================

XIncludeFile "Modules\AddPerson.pbi"                                                          ; 
XIncludeFile "Modules\CopyPerson.pbi"                                                         ; 
XIncludeFile "Modules\DeletePerson.pbi"                                                       ; 
XIncludeFile "Modules\EditPerson.pbi"                                                         ; 
XIncludeFile "Modules\PrintPerson.pbi"                                                        ; 
XIncludeFile "Modules\PrintPerson.pbi"                                                        ; 
XIncludeFile "Modules\TagPeople.pbi"                                                          ; 

;==========================================================================================================================
; Utility menu includes
;==========================================================================================================================

XIncludeFile "Modules\BackupDatabase.pbi"                                                     ; 
XIncludeFile "Modules\ExportAddresses.pbi"                                                    ; 
XIncludeFile "Modules\ImportAddresses.pbi"                                                    ; 
XIncludeFile "Modules\UpdatePostcodes.pbi"                                                    ; 

;==========================================================================================================================
; Setup menu includes
;==========================================================================================================================

XIncludeFile "Modules\ShowData.pbi"                                                           ; 
XIncludeFile "Modules\ShowClock.pbi"                                                          ; 
XIncludeFile "Modules\ShowTooltips.pbi"                                                       ; 
XIncludeFile "Modules\MailSetup.pbi"                                                          ; 

;==========================================================================================================================
; Help menu includes
;==========================================================================================================================

XIncludeFile "Modules\AboutProgram.pbi"                                                       ; 
XIncludeFile "Modules\ShowHelp.pbi"                                                           ; 
XIncludeFile "Modules\KeyboardShortcuts.pbi"                                                  ; 

;==========================================================================================================================
; Main event handling section
;==========================================================================================================================

 ;------------------------------------------------------------------------------------------------
 ; Set the startup program quit value flag
 ;------------------------------------------------------------------------------------------------

 Program\QuitValue = 0

 ;------------------------------------------------------------------------------------------------
 ; Enable the displaying of balloon tooltips
 ;------------------------------------------------------------------------------------------------

 Program\ToolTips = 1

 ;------------------------------------------------------------------------------------------------
 ; Create my main menu
 ;------------------------------------------------------------------------------------------------

 CreateMainMenu()

 ;------------------------------------------------------------------------------------------------
 ; Setup the window tool tips
 ;------------------------------------------------------------------------------------------------

 SelectWindowToolTips(#Window_AddressBox)

 ;------------------------------------------------------------------------------------------------
 ; Open the master database
 ;------------------------------------------------------------------------------------------------

 OpenSystemDatabase()

 ;------------------------------------------------------------------------------------------------
 ; Set focus to main window
 ;------------------------------------------------------------------------------------------------

 SetActiveWindow(#Window_AddressBox)

      ;-----------------------------------------------
      ; 
      ;-----------------------------------------------

      Case #PB_Event_Menu
        Select EventMenu()
;         Files Menu
          Case #ShortCut_OpenDatabase                   : OpenDatabase()
          Case #ShortCut_ReloadMaster                   : ReloadMaster()
          Case #ShortCut_DumpTables                     : DumpTables()
          Case #ShortCut_UndumpTables                   : UndumpTables()
          Case #ShortCut_VacuumTables                   : VacuumTables()
          Case #ShortCut_ExitProgram                    : ExitProgram()
;         Category Menu
          Case #ShortCut_AddCategory                    : AddCategory()
          Case #ShortCut_CopyCategory                   : CopyCategory()
          Case #ShortCut_DeleteCategory                 : DeleteCategory()
          Case #ShortCut_EditCategory                   : EditCategory()
;         Data Menu
          Case #ShortCut_AddPerson                      : AddPerson()
          Case #ShortCut_CopyPerson                     : CopyPerson()
          Case #ShortCut_DeletePerson                   : DeletePerson()
          Case #ShortCut_EditPerson                     : EditPerson()
          Case #ShortCut_PrintPerson                    : PrintPerson()
          Case #ShortCut_PrintPerson                    : PrintPerson()
          Case #ShortCut_TagPeople                      : TagPeople()
;         Utility Menu
          Case #ShortCut_BackupDatabase                 : BackupDatabase()
          Case #ShortCut_ExportAddresses                : ExportAddresses()
          Case #ShortCut_ImportAddresses                : ImportAddresses()
          Case #ShortCut_UpdatePostcodes                : UpdatePostcodes()
;         Setup Menu
          Case #ShortCut_ShowData                       : ShowData()
          Case #ShortCut_ShowClock                      : ShowClock()
          Case #ShortCut_ShowTooltips                   : ShowTooltips()
          Case #ShortCut_MailSetup                      : MailSetup()
;         Help Menu
          Case #ShortCut_AboutProgram                   : AboutProgram()
          Case #ShortCut_ShowHelp                       : ShowHelp()
          Case #ShortCut_KeyboardShortcuts              : KeyboardShortcuts()
          ;-------------------------------------------
          ; 
          ;-------------------------------------------
;         Files Menu
          Case #MenuBar_OpenDatabase                    : OpenDatabase()
          Case #MenuBar_ReloadMaster                    : ReloadMaster()
          Case #MenuBar_DumpTables                      : DumpTables()
          Case #MenuBar_UndumpTables                    : UndumpTables()
          Case #MenuBar_VacuumTables                    : VacuumTables()
          Case #MenuBar_ExitProgram                     : ExitProgram()
;         Category Menu
          Case #MenuBar_AddCategory                     : AddCategory()
          Case #MenuBar_CopyCategory                    : CopyCategory()
          Case #MenuBar_DeleteCategory                  : DeleteCategory()
          Case #MenuBar_EditCategory                    : EditCategory()
;         Data Menu
          Case #MenuBar_AddPerson                       : AddPerson()
          Case #MenuBar_CopyPerson                      : CopyPerson()
          Case #MenuBar_DeletePerson                    : DeletePerson()
          Case #MenuBar_EditPerson                      : EditPerson()
          Case #MenuBar_PrintPerson                     : PrintPerson()
          Case #MenuBar_PrintPerson                     : PrintPerson()
          Case #MenuBar_TagPeople                       : TagPeople()
;         Utility Menu
          Case #MenuBar_BackupDatabase                  : BackupDatabase()
          Case #MenuBar_ExportAddresses                 : ExportAddresses()
          Case #MenuBar_ImportAddresses                 : ImportAddresses()
          Case #MenuBar_UpdatePostcodes                 : UpdatePostcodes()
;         Setup Menu
          Case #MenuBar_ShowData                        : ShowData()
          Case #MenuBar_ShowClock                       : ShowClock()
          Case #MenuBar_ShowTooltips                    : ShowTooltips()
          Case #MenuBar_MailSetup                       : MailSetup()
;         Help Menu
          Case #MenuBar_AboutProgram                    : AboutProgram()
          Case #MenuBar_ShowHelp                        : ShowHelp()
          Case #MenuBar_KeyboardShortcuts               : KeyboardShortcuts()
          ;-------------------------------------------
          ; 
          ;-------------------------------------------
        EndSelect
      ;-----------------------------------------------
      ; 
      ;-----------------------------------------------
