
;==========================================================================================================================
; Keyboard shortcuts loader procedure
;==========================================================================================================================

PROCEDURE LoadkeyboardShortCuts()

  ;------------------------------------------------------------------------------------------------
  ; Remove all existing shortcuts for this window
  ;------------------------------------------------------------------------------------------------

  RemoveKeyboardShortcut(#Window_AddressBox, #PB_Shortcut_All)

  ;------------------------------------------------------------------------------------------------
  ; Load the keyboard shortcuts from the system database
  ;------------------------------------------------------------------------------------------------

  If DatabaseQuery(Program\DatabaseHandle, "Select * FROM KeyboardShortcuts WHERE Record='1'"

    While NextDatabaseRow(Program\DatabaseHandle)

      Keys\OpenDatabase               = Val(GetDatabaseString(Program\DatabaseHandle,  0))

      Keys\ReloadMaster               = Val(GetDatabaseString(Program\DatabaseHandle,  1))

      Keys\DumpTables                 = Val(GetDatabaseString(Program\DatabaseHandle,  2))

      Keys\UndumpTables               = Val(GetDatabaseString(Program\DatabaseHandle,  3))

      Keys\VacuumTables               = Val(GetDatabaseString(Program\DatabaseHandle,  4))

      Keys\ExitProgram                = Val(GetDatabaseString(Program\DatabaseHandle,  5))

      Keys\AddCategory                = Val(GetDatabaseString(Program\DatabaseHandle,  6))

      Keys\CopyCategory               = Val(GetDatabaseString(Program\DatabaseHandle,  7))

      Keys\DeleteCategory             = Val(GetDatabaseString(Program\DatabaseHandle,  8))

      Keys\EditCategory               = Val(GetDatabaseString(Program\DatabaseHandle,  9))

      Keys\AddPerson                  = Val(GetDatabaseString(Program\DatabaseHandle,  10))

      Keys\CopyPerson                 = Val(GetDatabaseString(Program\DatabaseHandle,  11))

      Keys\DeletePerson               = Val(GetDatabaseString(Program\DatabaseHandle,  12))

      Keys\EditPerson                 = Val(GetDatabaseString(Program\DatabaseHandle,  13))

      Keys\PrintPerson                = Val(GetDatabaseString(Program\DatabaseHandle,  14))

      Keys\PrintPerson                = Val(GetDatabaseString(Program\DatabaseHandle,  15))

      Keys\TagPeople                  = Val(GetDatabaseString(Program\DatabaseHandle,  16))

      Keys\BackupDatabase             = Val(GetDatabaseString(Program\DatabaseHandle,  17))

      Keys\ExportAddresses            = Val(GetDatabaseString(Program\DatabaseHandle,  18))

      Keys\ImportAddresses            = Val(GetDatabaseString(Program\DatabaseHandle,  19))

      Keys\UpdatePostcodes            = Val(GetDatabaseString(Program\DatabaseHandle,  20))

      Keys\ShowData                   = Val(GetDatabaseString(Program\DatabaseHandle,  21))

      Keys\ShowClock                  = Val(GetDatabaseString(Program\DatabaseHandle,  22))

      Keys\ShowTooltips               = Val(GetDatabaseString(Program\DatabaseHandle,  23))

      Keys\MailSetup                  = Val(GetDatabaseString(Program\DatabaseHandle,  24))

      Keys\AboutProgram               = Val(GetDatabaseString(Program\DatabaseHandle,  25))

      Keys\ShowHelp                   = Val(GetDatabaseString(Program\DatabaseHandle,  26))

      Keys\KeyboardShortcuts          = Val(GetDatabaseString(Program\DatabaseHandle,  27))

    Wend
  ;
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------

    FinishDatabaseQuery(Program\DatabaseHandle)
  ;
  ;------------------------------------------------------------------------------------------------
  ; Reload the shortcuts with the new values.
  ;------------------------------------------------------------------------------------------------

    AddKeyboardShortcut(#Window_AddressBox, Keys\OpenDatabase,             #ShortCut_OpenDatabase)

    AddKeyboardShortcut(#Window_AddressBox, Keys\ReloadMaster,             #ShortCut_ReloadMaster)

    AddKeyboardShortcut(#Window_AddressBox, Keys\DumpTables,               #ShortCut_DumpTables)

    AddKeyboardShortcut(#Window_AddressBox, Keys\UndumpTables,             #ShortCut_UndumpTables)

    AddKeyboardShortcut(#Window_AddressBox, Keys\VacuumTables,             #ShortCut_VacuumTables)

    AddKeyboardShortcut(#Window_AddressBox, Keys\ExitProgram,              #ShortCut_ExitProgram)

    AddKeyboardShortcut(#Window_AddressBox, Keys\AddCategory,              #ShortCut_AddCategory)

    AddKeyboardShortcut(#Window_AddressBox, Keys\CopyCategory,             #ShortCut_CopyCategory)

    AddKeyboardShortcut(#Window_AddressBox, Keys\DeleteCategory,           #ShortCut_DeleteCategory)

    AddKeyboardShortcut(#Window_AddressBox, Keys\EditCategory,             #ShortCut_EditCategory)

    AddKeyboardShortcut(#Window_AddressBox, Keys\AddPerson,                #ShortCut_AddPerson)

    AddKeyboardShortcut(#Window_AddressBox, Keys\CopyPerson,               #ShortCut_CopyPerson)

    AddKeyboardShortcut(#Window_AddressBox, Keys\DeletePerson,             #ShortCut_DeletePerson)

    AddKeyboardShortcut(#Window_AddressBox, Keys\EditPerson,               #ShortCut_EditPerson)

    AddKeyboardShortcut(#Window_AddressBox, Keys\PrintPerson,              #ShortCut_PrintPerson)

    AddKeyboardShortcut(#Window_AddressBox, Keys\PrintPerson,              #ShortCut_PrintPerson)

    AddKeyboardShortcut(#Window_AddressBox, Keys\TagPeople,                #ShortCut_TagPeople)

    AddKeyboardShortcut(#Window_AddressBox, Keys\BackupDatabase,           #ShortCut_BackupDatabase)

    AddKeyboardShortcut(#Window_AddressBox, Keys\ExportAddresses,          #ShortCut_ExportAddresses)

    AddKeyboardShortcut(#Window_AddressBox, Keys\ImportAddresses,          #ShortCut_ImportAddresses)

    AddKeyboardShortcut(#Window_AddressBox, Keys\UpdatePostcodes,          #ShortCut_UpdatePostcodes)

    AddKeyboardShortcut(#Window_AddressBox, Keys\ShowData,                 #ShortCut_ShowData)

    AddKeyboardShortcut(#Window_AddressBox, Keys\ShowClock,                #ShortCut_ShowClock)

    AddKeyboardShortcut(#Window_AddressBox, Keys\ShowTooltips,             #ShortCut_ShowTooltips)

    AddKeyboardShortcut(#Window_AddressBox, Keys\MailSetup,                #ShortCut_MailSetup)

    AddKeyboardShortcut(#Window_AddressBox, Keys\AboutProgram,             #ShortCut_AboutProgram)

    AddKeyboardShortcut(#Window_AddressBox, Keys\ShowHelp,                 #ShortCut_ShowHelp)

    AddKeyboardShortcut(#Window_AddressBox, Keys\KeyboardShortcuts,        #ShortCut_KeyboardShortcuts)

  Else

    ; Problem with the database query

  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure
