﻿;==========================================================================================================================
; Need a unicode aware version of the API directory creator
;==========================================================================================================================

Import "shell32.lib"                                                                    ; 
  SHCreateDirectory(*hwnd, pszPath.p-unicode)                                            ; 
EndImport                                                                               ; 

;==========================================================================================================================
; My personal constants
;==========================================================================================================================

#Author                         = "Bozo Da Clown"                                       ; Author's name
#Basename                       = "ShortCutter(c), "                                    ; Base name for ini and dataabse
#Version                        = "v1.00, "                                             ; Program version
#Regstring                      = "Freeware, "                                          ; Registration string

#Program                        = #BaseName + #Version + #Regstring                     ; Copyright string

;==========================================================================================================================
; My program data structure
;==========================================================================================================================

Structure ProgramData                                                                  ; Program data structure
  QuitValue.i                                                                           ; Program quit value
  DragItem.i                                                                            ; Dragging items between rows
  WindowMutex.i                                                                         ; Window lock mutex
  LastWindow.s                                                                          ; The last window opened
  CurrentLine.i                                                                         ; Currently selected line
  
  CurrentDirectory.s                                                                    ; The current program directory
  ProjectDirectory.s                                                                    ; The exported to project directory
  IconDirectory.s                                                                       ; The exported to project icons directory
  ModuleDirectory.s                                                                     ; The exported to project include files directory
  
  OldWindowTitle.s                                                                      ; Title of the old main program window
  WindowName.s                                                                          ; Name of the window that this code targets
  ProjectName.s                                                                         ; Name of the projects' program name for export
EndStructure                                                                           ; 

;==========================================================================================================================
; Shortcut keys data structure
;==========================================================================================================================

Structure KeysData                                                                     ; Keyboard shortcuts data structure
  KeyDataText.s                                                                         ; The variable name with spaces as menu text
  KeyDataName.s                                                                         ; The variable name without spaces
  KeyDataValue.s                                                                        ; The PB key value of the text shortcut key
  KeyDataKeys.s                                                                         ; The text representation of the shortcut
  KeyDataBalloon.s                                                                      ; The shortcut full text as used in balloon tooltips
  KeyDataIcon.s                                                                         ; The icon for the menubar if any
EndStructure

;==========================================================================================================================
; Global variables
;==========================================================================================================================

Global Program.ProgramData                                                             ; Program data list
Global NewList Keys.KeysData()                                                        ; Keyboard shortcuts data list

;==========================================================================================================================
; Other variables
;==========================================================================================================================

Program\DragItem        = -1                                                            ; Initial item drag state

;==========================================================================================================================
; Get working directories
;==========================================================================================================================

Program\CurrentDirectory    = GetCurrentDirectory()                                     ; Get the current working directory
Program\ProjectDirectory    = Program\CurrentDirectory + "Project\"                     ; The project directory
Program\IconDirectory       = Program\ProjectDirectory + "Icons\"                       ; The project's icons
Program\ModuleDirectory     = Program\ProjectDirectory + "Modules\"                     ; The project's modules

;==========================================================================================================================
; Create the directories if you can
;==========================================================================================================================

MakeSureDirectoryPathExists(Program\ProjectDirectory)                                   ; Create the project directory
MakeSureDirectoryPathExists(Program\IconDirectory)                                      ; Create the project icons directory
MakeSureDirectoryPathExists(Program\ModuleDirectory)                                    ; Create the project include files directory

;==========================================================================================================================
; Program images
;==========================================================================================================================

Enumeration #ImageIndex
  #HeadingMarker                                                                        ; Menu heading marker icon
EndEnumeration

;==========================================================================================================================
; Catch the icons form the data section
;==========================================================================================================================

CatchImage(#HeadingMarker,      ?_HeadingMarker)                                        ; Program menu heading icons

;==========================================================================================================================
; Include icons in the EXE file
;==========================================================================================================================

DataSection
  _HeadingMarker:   IncludeBinary "Images\blackrightarrow16X16.ico"                    ; Black arrow heading icon
EndDataSection

; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 17
; EnableXP