﻿;==========================================================================================================================
; Generic modules as made almost entirely by others
;==========================================================================================================================

Declare.s FormatField(InString.s, FieldLen.i)                                           ; Format the passed string to the correct field length for printing
Declare.s GetShortcutText(State.i)                                                      ; Get the text of the associated shortcut constant
Declare   ListIconGadgetMove(GadgetNumber.i, Position.i, Destination.i)                 ; Move lines around in a single ListIconGadget
Declare   MakeSureDirectoryPathExists(Directory.s)                                      ; Need a unicode aware version of the API directory creator
Declare   MixedStringCase(Gadget.i)                                                     ; First letter uppercase in a string box. srod!

;==========================================================================================================================
; Custom modules by me
;==========================================================================================================================

Declare   ClearShortCuts()                                                              ; Clear all shortcuts from the list
Declare   CloseMyWindow(WindowId.i)                                                     ; Custom window closer with variable cleanup
Declare   CopyShortcutToList()                                                          ; Copy the current shortcut to the key list
Declare   CountShortCuts()                                                              ; Count the number of shortcuts in the list. Excluding menu titles
Declare   ExportShortCutsToCode()                                                       ; Export keyboard shortcuts to pb include file
Declare   GetIconForShortCut()                                                          ; Link an icon for the shortcut menu
Declare   GetProjectDetails()                                                           ; Get the window and program names to export for
Declare   SaveProjectDetails()                                                          ; Save the project window and program names for this session
Declare   ListIconGadgetColumns(GadgetNumber.i)                                         ; Count the number of columns in a ListIconGadget
Declare   ShortCutToValue()                                                             ; Copy shortcut value to edit form
Declare   WriteHeadingToOutputFile(FileHandle.i, HeadingString.s)                       ; Shorten the heading creation for the output files/files

;==========================================================================================================================
; Shortcut data handling
;==========================================================================================================================

Declare   AddShortCut()                                                                 ; Add a new shortcut to the list
Declare   CopyShortCut()                                                                ; Copy shortcut to the clipboard
Declare   DeleteShortCut()                                                              ; Delete the currently selected shortcut
Declare   EditShortCut()                                                                ; Edit the selected shortcut
Declare   SaveShortCut()                                                                ; Save the new or changed shortcut

;==========================================================================================================================
; Shortcut menu heading handling
;==========================================================================================================================

Declare   AddShortCutHeading()                                                          ; Add a new shortcut menu heading
Declare   DeleteShortCutHeading()                                                       ; Delete the shortcut menu heading
Declare   EditShortCutHeading()                                                         ; Edit the shortcut menu heading
Declare   SaveShortCutHeading()                                                         ; Save the changed shortcut heading

;==========================================================================================================================
; Loading and saving shortcuts
;==========================================================================================================================

Declare   LoadShortCutsFromDisk()                                                       ; Load a shortcuts key list from disk
Declare   SaveShortCutsFromDisk()                                                       ; Save the shortcuts key list to disk

;==========================================================================================================================
; 
;==========================================================================================================================

Declare  CreateEmptyProcedures()                                                        ; Create the empty procedures
Declare  LoadkeyboardShortCutsFile()                                                    ; Create the keyboard shortcuts loader
Declare  MainMenuFile()                                                                 ; Create the main program menu file
Declare  MainProgramFile()                                                              ; Create the main program file
Declare  MakeSureDirectoryPathExistsFile()                                              ; Create the directory creator procedure
Declare  MyBalloonToolTipsFile()                                                        ; Create the balloon tooltips handler
Declare  MyConstantsFile()                                                              ; Create the program constants file
Declare  MyDeclarationsFile()                                                           ; Create the declaration include file
Declare  OpenSystemDatabaseFile()                                                       ; Create the system database procedure
Declare  SelectWindowToolTipsFile()                                                     ; Create the window tooltips selector


; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 56
; FirstLine = 28
; Markers = 22
; EnableXP